// IlpilboxDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Ilpilbox.h"
#include "IlpilboxDlg.h"

#define VERSION   "1.66"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CIlpilboxApp theApp;

#ifdef _DEBUG
LPCTSTR szNoTitle = _T("ILPilbox ")_T(VERSION)_T(" Debug");
#else
LPCTSTR szNoTitle = _T("ILPilbox ")_T(VERSION);
#endif

static const LPCTSTR szLicence =
	_T("This program is free software; you can redistribute it and/or modify\r\n")
	_T("it under the terms of the GNU General Public License as published by\r\n")
	_T("the Free Software Foundation; either version 2 of the License, or\r\n")
	_T("(at your option) any later version.\r\n")
	_T("\r\n")
	_T("This program is distributed in the hope that it will be useful,\r\n")
	_T("but WITHOUT ANY WARRANTY; without even the implied warranty of\r\n")
	_T("MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.\r\n")
	_T("See the GNU General Public License for more details.\r\n")
	_T("\r\n")
	_T("You should have received a copy of the GNU General Public License along\r\n")
	_T("with this program; if not, write to the Free Software Foundation, Inc.,\r\n")
	_T("51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.");

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BOOL CAboutDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	SetDlgItemText(IDC_VERSION,szNoTitle);
	SetDlgItemText(IDC_LICENSE,szLicence);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

/////////////////////////////////////////////////////////////////////////////
// CIlpilboxDlg dialog

CIlpilboxDlg::CIlpilboxDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CIlpilboxDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CIlpilboxDlg)
	m_strAddrOut = _T("localhost");
	m_uPortOut = 60001;
	m_uPortIn = 60000;
	m_dwConnectTimeout = 0xFFFFFFFF;		// client connect timeout in us (default blocked connect timeout)
	m_bPilboxIDY = FALSE;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	m_dwBaudRate = 0;						// auto baudrate

	m_bEnableRFC = TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CIlpilboxDlg settings helper functions

CString CIlpilboxDlg::ReadString(LPCTSTR lpszSection, LPCTSTR lpszEntry, LPCTSTR lpszDefault)
{
	if (*theApp.m_szIniFile != 0)
	{
		TCHAR cBuffer[1024];

		::GetPrivateProfileString(lpszSection,lpszEntry,lpszDefault,cBuffer,ARRAYSIZEOF(cBuffer),theApp.m_szIniFile);
		return CString(cBuffer);
	}
	else
	{
		return AfxGetApp()->GetProfileString(lpszSection,lpszEntry,lpszDefault);
	}
}

UINT CIlpilboxDlg::ReadInt(LPCTSTR lpszSection, LPCTSTR lpszEntry, INT nDefault)
{
	if (*theApp.m_szIniFile != 0)
	{
		return ::GetPrivateProfileInt(lpszSection,lpszEntry,nDefault,theApp.m_szIniFile);
	}
	else
	{
		return AfxGetApp()->GetProfileInt(lpszSection,lpszEntry,nDefault);
	}
}

BOOL CIlpilboxDlg::WriteString(LPCTSTR lpszSection, LPCTSTR lpszEntry, LPCTSTR lpszValue)
{
	if (*theApp.m_szIniFile != 0)
	{
		return ::WritePrivateProfileString(lpszSection,lpszEntry,lpszValue,theApp.m_szIniFile);
	}
	else
	{
		return AfxGetApp()->WriteProfileString(lpszSection,lpszEntry,lpszValue);
	}
}

BOOL CIlpilboxDlg::WriteInt(LPCTSTR lpszSection, LPCTSTR lpszEntry, INT nValue)
{
	if (*theApp.m_szIniFile != 0)
	{
		TCHAR s[16];
		wsprintf(s,_T("%u"),nValue);
		return ::WritePrivateProfileString(lpszSection,lpszEntry,s,theApp.m_szIniFile);
	}
	else
	{
		return AfxGetApp()->WriteProfileInt(lpszSection,lpszEntry,nValue);
	}
}

void CIlpilboxDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CIlpilboxDlg)
	DDX_Control(pDX, IDC_STOP, m_CButStop);
	DDX_Control(pDX, IDC_START, m_CButStart);
	DDX_Control(pDX, IDC_COMPORT, m_CComboPort);
	DDX_Text(pDX, IDC_ADDR_OUT, m_strAddrOut);
	DDX_Text(pDX, IDC_PORT_OUT, m_uPortOut);
	DDX_Text(pDX, IDC_PORT_IN, m_uPortIn);
	DDX_Check(pDX, IDC_IDYFRAMES, m_bPilboxIDY);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CIlpilboxDlg, CDialog)
	//{{AFX_MSG_MAP(CIlpilboxDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_START, OnStart)
	ON_BN_CLICKED(IDC_STOP, OnStop)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CIlpilboxDlg message handlers

BOOL CIlpilboxDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "Help Topics..." and "About..." menu items to the system menu.

	// IDM_HELPTOPICS must be in the system command range.
	ASSERT((IDM_HELPTOPICS & 0xFFF0) == IDM_HELPTOPICS);
	ASSERT(IDM_HELPTOPICS < 0xF000);

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strText;
		pSysMenu->AppendMenu(MF_SEPARATOR);

		strText.LoadString(IDS_HELP_TOPICS);
		pSysMenu->AppendMenu(MF_STRING, IDM_HELPTOPICS, strText);

		strText.LoadString(IDS_ABOUTBOX);
		pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strText);
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
//	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	m_CButStart.EnableWindow(TRUE);
	m_CButStop.EnableWindow(FALSE);

	if (*theApp.m_szIniFile != 0)			// ini file given
	{
		CString strTitle,strAppTitle;

		// new document title
		GetWindowText(strAppTitle);
		strTitle.Format(_T("%s - %s"),strAppTitle,theApp.m_lpFilePart);
		SetWindowText(strTitle);	// set document title with ini file
	}

	// get actual window position
	WINDOWPLACEMENT wndpl;
	wndpl.length = sizeof(wndpl);
	GetWindowPlacement(&wndpl);

	// settings
	m_nPosX            = ReadInt(_T("Settings"),_T("WinPosX"),wndpl.rcNormalPosition.left);
	m_nPosY            = ReadInt(_T("Settings"),_T("WinPosY"),wndpl.rcNormalPosition.top);
	m_strAddrOut       = ReadString(_T("Settings"),_T("AddrOut"),m_strAddrOut);
	m_uPortOut         = ReadInt(_T("Settings"),_T("PortOut"),m_uPortOut);
	m_uPortIn          = ReadInt(_T("Settings"),_T("PortIn"),m_uPortIn);
	m_dwConnectTimeout = ReadInt(_T("Settings"),_T("ConnectTimeout"),m_dwConnectTimeout);
	m_strComPort       = ReadString(_T("Settings"),_T("Port"),m_strComPort);
	m_dwBaudRate       = ReadInt(_T("Settings"),_T("BaudRate"),m_dwBaudRate);
	m_bPilboxIDY       = ReadInt(_T("Settings"),_T("PilboxIDY"),m_bPilboxIDY);
	m_bEnableRFC       = ReadInt(_T("Settings"),_T("EnableRFC"),m_bEnableRFC);

	SetWindowLocation(m_nPosX,m_nPosY);		// set windows location
	SetCommList(m_strComPort);				// update COM port combo box
	UpdateData(FALSE);

	// press the "Start" button
	if (theApp.m_bStart) PostMessage(WM_COMMAND,IDC_START);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

BOOL CIlpilboxDlg::PreTranslateMessage(MSG* pMsg) 
{
	// TODO: Add your specialized code here and/or call the base class
	if (pMsg->message == WM_KEYDOWN && pMsg->wParam == VK_ESCAPE)
	{
		return TRUE;  // disable the ESC key quitting the application
	}
	return CDialog::PreTranslateMessage(pMsg);
}

void CIlpilboxDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	switch (nID & 0xFFF0)
	{
	case IDM_HELPTOPICS:
		ShellExecute(GetSafeHwnd(),
					 _T("open"),
					 _T("ILPilbox.htm"),
					 NULL,
					 _T(""),
					 SW_SHOWNORMAL);
		break;
	case IDM_ABOUTBOX:
		CAboutDlg().DoModal();
		break;
	default:
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CIlpilboxDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CIlpilboxDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

// set window location
VOID CIlpilboxDlg::SetWindowLocation(INT nPosX,INT nPosY)
{
	WINDOWPLACEMENT wndpl;
	RECT *pRc = &wndpl.rcNormalPosition;

	wndpl.length = sizeof(wndpl);
	GetWindowPlacement(&wndpl);
	pRc->right = pRc->right - pRc->left + nPosX;
	pRc->bottom = pRc->bottom - pRc->top + nPosY;
	pRc->left = nPosX;
	pRc->top = nPosY;
	SetWindowPlacement(&wndpl);
	return;
}

// set listfield for serial combo boxe
VOID CIlpilboxDlg::SetCommList(LPCTSTR szComPort)
{
	INT  nSelect;
	HKEY hKey;

	m_CComboPort.ResetContent();			// delete current list

	nSelect = 0;							// set selection to 1st one

	if (RegOpenKeyEx(HKEY_LOCAL_MACHINE,
					 _T("Hardware\\DeviceMap\\SerialComm"),
					 0,
					 KEY_QUERY_VALUE | KEY_ENUMERATE_SUB_KEYS,
					 &hKey) == ERROR_SUCCESS)
	{
		TCHAR cKey[256],cData[256];
		DWORD dwKeySize,dwDataSize;
		INT   nSelIndex;
		BOOL  bFound;
		DWORD dwType,dwEnumVal;
		LONG  lRet;

		nSelIndex = 0;						// preset selector
		bFound = FALSE;						// preset not found

		dwEnumVal = 0;
		do
		{
			dwKeySize = ARRAYSIZEOF(cKey);	// init return buffer sizes
			dwDataSize = sizeof(cData);

			lRet = RegEnumValue(hKey,dwEnumVal++,
								cKey,&dwKeySize,
								NULL,&dwType,
								(LPBYTE) cData,&dwDataSize);

			if (lRet == ERROR_SUCCESS && dwType == REG_SZ)
			{
				if (lstrcmp(cData,szComPort) == 0)
				{
					nSelect = nSelIndex;
					bFound = TRUE;
				}

				m_CComboPort.AddString(cData);
				++nSelIndex;
			}
		}
		while (lRet == ERROR_SUCCESS);
		_ASSERT(lRet == ERROR_NO_MORE_ITEMS);
		RegCloseKey(hKey);

		if (!bFound)						// port doesn't exists any more
		{
			// add it anyway
			m_CComboPort.AddString(szComPort);
			nSelect = nSelIndex;
		}
	}

	m_CComboPort.SetCurSel(nSelect);		// set cursor
	return;
}

void CIlpilboxDlg::OnStart() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);

	// get COM port setting from combo box
	m_CComboPort.GetWindowText(m_strComPort);

	theApp.m_pPilBoxObj = new CInterface(m_strComPort,
										 m_dwBaudRate,
										 m_bPilboxIDY != FALSE,
										 m_bEnableRFC != FALSE,
										 this);

	// add initialization of TCP/IP server
	theApp.m_pTcpIpObj = new CTcpIp(m_strAddrOut,m_uPortOut,m_uPortIn,m_dwConnectTimeout);

	if (theApp.m_pPilBoxObj != NULL)
	{
		// port and PILBox found
		if (theApp.m_pPilBoxObj->Connect() == false)
		{
			ASSERT(theApp.m_pPilBoxObj);	// free Interface class
			delete theApp.m_pPilBoxObj;
			theApp.m_pPilBoxObj = NULL;
		}
	}

	if (theApp.m_pPilBoxObj != NULL && theApp.m_pTcpIpObj != NULL)
	{
		// TCP/IP server initialization failed
		if (theApp.m_pTcpIpObj->Connect() == false)
		{
			ASSERT(theApp.m_pTcpIpObj);		// free Interface class
			delete theApp.m_pTcpIpObj;
			theApp.m_pTcpIpObj = NULL;
		}
	}

	// both interfaces successful installed
	if (theApp.m_pPilBoxObj != NULL && theApp.m_pTcpIpObj != NULL)
	{
		m_CComboPort.EnableWindow(FALSE);
		GetDlgItem(IDC_IDYFRAMES)->EnableWindow(FALSE);
		m_CButStart.SetButtonStyle(BS_PUSHBUTTON);
		m_CButStart.EnableWindow(FALSE);
		m_CButStop.EnableWindow(TRUE);
		m_CButStop.SetButtonStyle(BS_DEFPUSHBUTTON);
		m_CButStop.SetFocus();

		GetDlgItem(IDC_ADDR_OUT)->EnableWindow(FALSE);
		GetDlgItem(IDC_PORT_OUT)->EnableWindow(FALSE);
		GetDlgItem(IDC_PORT_IN)->EnableWindow(FALSE);
	}
	else									// error
	{
		OnStop();							// free the interfaces
	}
}

void CIlpilboxDlg::OnStop()
{
	// TODO: Add your control notification handler code here
	if (theApp.m_pTcpIpObj != NULL)
	{
		ASSERT(theApp.m_pTcpIpObj != NULL);
		theApp.m_pTcpIpObj->Disconnect();	// disconnect TCP/IP server
	}

	if (theApp.m_pPilBoxObj  != NULL)
	{
		ASSERT(theApp.m_pPilBoxObj != NULL);
		theApp.m_pPilBoxObj->Disconnect();	// stop Pilbox interface thread

		// quit Interface worker thread
		ASSERT(theApp.m_pPilBoxObj);
		delete theApp.m_pPilBoxObj;
		theApp.m_pPilBoxObj = NULL;
	}

	if (theApp.m_pTcpIpObj != NULL)
	{
		// quit TCP/IP worker thread
		ASSERT(theApp.m_pTcpIpObj != NULL);
		delete theApp.m_pTcpIpObj;
		theApp.m_pTcpIpObj = NULL;
	}

	m_CComboPort.EnableWindow(TRUE);
	GetDlgItem(IDC_IDYFRAMES)->EnableWindow(TRUE);
	m_CButStop.SetButtonStyle(BS_PUSHBUTTON);
	m_CButStop.EnableWindow(FALSE);
	m_CButStart.EnableWindow(TRUE);
	m_CButStart.SetButtonStyle(BS_DEFPUSHBUTTON);
	m_CButStart.SetFocus();

	GetDlgItem(IDC_ADDR_OUT)->EnableWindow(TRUE);
	GetDlgItem(IDC_PORT_OUT)->EnableWindow(TRUE);
	GetDlgItem(IDC_PORT_IN)->EnableWindow(TRUE);
}

void CIlpilboxDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	// interfaces running
	if (theApp.m_pPilBoxObj != NULL || theApp.m_pTcpIpObj != NULL)
	{
		OnStop();
		PostMessage(WM_COMMAND,IDCANCEL,0);	// call myself, until thread finished
		return;
	}

	// save current settings
	UpdateData(TRUE);

	// get actual window position
	WINDOWPLACEMENT wndpl;
	wndpl.length = sizeof(wndpl);
	GetWindowPlacement(&wndpl);
	m_nPosX = wndpl.rcNormalPosition.left;
	m_nPosY = wndpl.rcNormalPosition.top;

	// get COM port setting from combo box
	m_CComboPort.GetWindowText(m_strComPort);

	TCHAR szAppFile[_MAX_PATH];				// full pathname of application
	GetModuleFileName(NULL,szAppFile,ARRAYSIZEOF(szAppFile));
	WriteString(_T("Run"),_T("App"),szAppFile);

	WriteInt(_T("Settings"),_T("WinPosX"),m_nPosX);
	WriteInt(_T("Settings"),_T("WinPosY"),m_nPosY);
	WriteString(_T("Settings"),_T("AddrOut"),m_strAddrOut);
	WriteInt(_T("Settings"),_T("PortOut"),m_uPortOut);
	WriteInt(_T("Settings"),_T("PortIn"),m_uPortIn);
	WriteInt(_T("Settings"),_T("ConnectTimeout"),m_dwConnectTimeout);
	WriteString(_T("Settings"),_T("Port"),m_strComPort);
	WriteInt(_T("Settings"),_T("BaudRate"),m_dwBaudRate);
	WriteInt(_T("Settings"),_T("PilboxIDY"),m_bPilboxIDY);
	WriteInt(_T("Settings"),_T("EnableRFC"),m_bEnableRFC);

	CDialog::OnCancel();
}
