// Interface.h: interface for the CInterface class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_INTERFACE_H__9336856C_253E_400E_8473_DCE9A2F36566__INCLUDED_)
#define AFX_INTERFACE_H__9336856C_253E_400E_8473_DCE9A2F36566__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CInterface
{
public:
	CInterface(LPCTSTR lpszComPort, DWORD dwBaudRate, bool bIDY, bool bEnableRFC, CWnd* pParent = NULL);
	virtual ~CInterface();

	CWnd* m_pParent;						// parent window

	VOID SendFrameCtrl(WORD wFrame);		// send a frame to the PILBox in the correct PILBox mode

	DWORD GetBaudRate() const { return m_dwBaudRate; }

	bool Connect();
	VOID Disconnect();

private:
	enum LOOP_STATE
	{
		LS_IDLE,							// no transfer pending
		LS_PILBOX,							// transfer intiated by the PILBox
		LS_TCPIP							// transfer intiated by TCP/IP
	};

	HANDLE m_hComm;
	bool   m_bRunning;
	bool   m_bConMode;						// switch to CON mode
	bool   m_bRecvEn;						// receiver enabled
	WORD   m_wMode;							// PILBox mode
	DWORD  m_dwReftime;						// last transmit time
	HANDLE m_hEvTimeout;					// event to kill timeout
	HANDLE m_hWorkerThread;

	bool   m_bUSE8BITS;						// use 8-bit format with PILBox
	const bool m_bIDY;						// enable IDY frames on USB
	DWORD  m_dwBaudRate;					// baud rate
	bool   m_bEnableRFC;					// enable a RFC behind a CMD frame
	BYTE   m_byLastHigh;					// store the last send/received high byte on serial
	HANDLE m_hEvent;						// event to synchronize PILBox and TCP/IP

	enum LOOP_STATE m_eState;				// transfer initator

	VOID  InitComm(DWORD dwBaudrate);		// initialize COM port
	DWORD GetTimeout(WORD wFrame);			// get frame dependend timeout of real IL hardware
	bool  SetPILBox(WORD wCmd,bool bInit = false);	// set PIL Box operational mode
	bool  PILBoxCmd(WORD wCmd);				// execute a PIL Box command
	VOID  SendFrame(WORD wFrame);			// send a frame to the PILBox (base function)
	VOID  PILBox(BYTE byVal);				// handle the PILBox answer

	static UINT ComThreadProc(LPVOID pParam);
};

#endif // !defined(AFX_INTERFACE_H__9336856C_253E_400E_8473_DCE9A2F36566__INCLUDED_)
