// TcpIp.h: interface for the CTcpIp class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TCPIP_H__03DF957A_0B15_4825_83B4_DD7D8C73E316__INCLUDED_)
#define AFX_TCPIP_H__03DF957A_0B15_4825_83B4_DD7D8C73E316__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CTcpIp  
{
public:
	CTcpIp(LPCTSTR lpszAddrOut, UINT uPortOut, UINT uPortIn, DWORD dwConnectTimeout = 0xFFFFFFFF);
	virtual ~CTcpIp();

	void SetConnectTimeout(DWORD dwConnectTimeout) { m_dwConnectTimeout = dwConnectTimeout; }

	bool Connect();
	void Disconnect();

	bool SendFrame(WORD wFrame);

private:
	bool    m_bRunning;

	SOCKET  m_sockfds[2];					// IPv4 and IPv6 socket
	INT     m_nNumSocks;
	SOCKET  m_cfd;
	SOCKET  m_sClient;						// client socket

	HANDLE  m_hWorkerThread;

	const CString m_strAddrOut;
	const UINT    m_uPortIn;
	const UINT    m_uPortOut;

	DWORD   m_dwConnectTimeout;				// non-blocked IO connect timeout in us,  0xFFFFFFFF is blocked IO connect

	__inline void SetNonBlockedIO(unsigned long flag);

	static UINT __stdcall ThreadTcpIpServer(LPVOID pParam);

	bool StartServer();
	void StopServer();
};

#endif // !defined(AFX_TCPIP_H__03DF957A_0B15_4825_83B4_DD7D8C73E316__INCLUDED_)
